use std::env;
// use reqwest::StatusCode;
use leptos::*;
use serde::{Deserialize, Serialize};
use serde_json;

// use crate::services::rich_text;

//pub struct Client {
//    access_token: String,
//    space_id: String,
//    base_url: String,
//    environment_id: String,
//}

//impl Client {
//    pub fn new(
//        access_token: &str,
//        space_id: &str,
//        base_url: &str,
//        environment_id: &str,
//    ) -> Client {
//        Client {
//            base_url: base_url.into(),
//            access_token: access_token.into(),
//            space_id: space_id.into(),
//            environment_id: environment_id.into(),
//        }
//    }

//    fn get_entries_url(&self, query_string: &str) -> String {
//        format!(
//            "{base_url}/{space_id}/environments/{environment}/entries{query_string}",
//            base_url = &self.base_url,
//            space_id = &self.space_id,
//            environment = &self.environment_id,
//            query_string = &query_string
//        )
//    }

//    pub async fn get_entries_by_query_string<T>(
//        &self,
//        query_string: &str
//    ) -> Result<Vec<T>, Box<dyn std::error::Error>>
//    where
//        for<'a> T: Serialize + Deserialize<'a>,
//    {
//        let url = self.get_entries_url(query_string);
//        let reqwest_client = reqwest::Client::new();
//        let request = reqwest_client.get(&url).bearer_auth(&self.access_token);
//        let response = request.send().await?;
//        let json_response = match response.status() {
//            StatusCode::OK => {
//                let json = response.json::<serde_json::Value>().await?;
//                Some(json)
//            },
//            StatusCode::NOT_FOUND => None,
//            _ => {
//                unimplemented!();
//            },
//        };
//        match json_response {
//            Some(json) => {
//                if let Some(items) = json.clone().get_mut("items") {
//                if items.is_array() {
//                    if let Some(includes) = json.get("includes") {
//                        self.resolve_array(items, includes)?;
//                    } else {
//                        let includes = serde_json::Value::default();
//                        self.resolve_array(items, &includes)?;
//                    }

//                    let ar_string = items.to_string();
//                    let entries = serde_json::from_str::<Vec<T>>(ar_string.as_str())?;
//                    Ok(entries)
//                } else {
//                    unimplemented!();
//                }
//            } else {
//                unimplemented!();
//            }
//            },
//            _ => unimplemented!(),
//        }
//    }

//    fn resolve_array(
//        &self,
//        value: &mut serde_json::Value,
//        includes: &serde_json::Value,
//    ) -> Result<(), Box<dyn std::error::Error>> {
//        let items = value.as_array_mut().unwrap();
//        for item in items {
//            if item.is_object() {
//                self.resolve_object(item, includes)?;
//            } else if item.is_string() || item.is_number() {
//                // do nothing
//            } else {
//                unimplemented!();
//            }
//        }
//        Ok(())
//    }

//    fn resolve_object(
//        &self,
//        value: &mut serde_json::Value,
//        includes: &serde_json::Value,
//    ) -> Result<(), Box<dyn std::error::Error>> {
//        if let Some(sys) = value.get("sys") {
//            if let Some(sys_type) = sys.get("type") {
//                if sys_type == "Entry" {
//                    self.resolve_entry(value, includes)?;
//                } else if sys_type == "Link" {
//                    self.resolve_link(value, includes)?;
//                } else {
//                    let node_type = value["nodeType"].clone();
//                    if node_type == "document" {
//                        // log::warn!("TODO: Richtext is not yet implemented");
//                    } else {
//                        unimplemented!(
//                            "{} - {} not implemented for {}",
//                            &sys_type,
//                            &node_type,
//                            &value
//                        );
//                    }
//                }
//            } else {
//                unimplemented!("sys.type do not exist, though sys exists") // TODO: Can this ever happen?
//            }
//        } else {
//            // Do nothing, as it likely a json object
//        }

//        Ok(())
//    }

//    fn resolve_asset(&self, value: &mut serde_json::Value) -> Result<(), Box<dyn std::error::Error>> {
//        if let Some(fields) = value.get_mut("fields") {
//            if fields.is_object() {
//                *value = fields.clone();
//            } else {
//                unimplemented!();
//            }
//        } else {
//            unimplemented!();
//        }

//        Ok(())
//    }

//    fn resolve_entry(
//        &self,
//        value: &mut serde_json::Value,
//        includes: &serde_json::Value,
//    ) -> Result<(), Box<dyn std::error::Error>> {
//        if let Some(fields) = value.get_mut("fields") {
//            if fields.is_object() {
//                let entry_object = fields.as_object_mut().unwrap();
//                for (_field_name, field_value) in entry_object {
//                    if field_value.is_object() {
//                        self.resolve_object(field_value, includes)?;
//                    } else if field_value.is_array() {
//                        self.resolve_array(field_value, includes)?;
//                    } else {
//                        // Regular string, number, etc, values. No need to do anything.
//                    }
//                }
//                *value = fields.clone();
//            } else {
//                unimplemented!();
//            }
//        } else {
//            unimplemented!();
//        }

//        Ok(())
//    }

//    fn resolve_link(
//        &self,
//        value: &mut serde_json::Value,
//        includes: &serde_json::Value,
//    ) -> Result<(), Box<dyn std::error::Error>> {
//        let link_type = value["sys"]["linkType"].clone();
//        let link_id = value["sys"]["id"].clone();
//        if link_type == "Entry" {
//            let included_entries = includes["Entry"].as_array().unwrap();
//            let mut filtered_entries = included_entries
//                .iter()
//                .filter(|entry| entry["sys"]["id"] == link_id)
//                .take(1);
//            let linked_entry = filtered_entries.next();
//            if let Some(entry) = linked_entry {
//                let mut entry = entry.clone();
//                self.resolve_entry(&mut entry, includes)?;
//                *value = entry;
//                //value["fields"] = entry["fields"].clone();
//                //*value = entry["fields"].clone();
//            }
//        } else if link_type == "Asset" {
//            let included_assets = includes["Asset"].as_array().unwrap();
//            let mut filtered_assets = included_assets
//                .iter()
//                .filter(|entry| entry["sys"]["id"] == link_id)
//                .take(1);
//            let linked_asset = filtered_assets.next();
//            if let Some(asset) = linked_asset {
//                let mut asset = asset.clone();
//                self.resolve_asset(&mut asset)?;
//                *value = asset;
//            }
//        } else {
//            unimplemented!();
//        }

//        //*value = value["fields"].clone();
//        Ok(())
//    }
//}

#[derive(Clone, Debug, Serialize, Deserialize)]
#[serde(rename_all = "camelCase")]
pub struct RichTextPage {
    pub title: String,
    pub page_slug: String,
    // pub rich_text_content: rich_text::RichTextNode,
    pub rich_text_content: serde_json::Value,
}

#[derive(Clone, Debug, Serialize, Deserialize)]
#[serde(rename_all = "camelCase")]
pub struct RichTextPageLanguagesWrapper {
    pub internal_title: String,
    pub english: RichTextPage,
}

#[server(GetRichTextPage, "/api", "GetJson")]
pub async fn get_rich_text_page(slug: String) -> Result<RichTextPageLanguagesWrapper, ServerFnError> {
    let contentful_client = get_contentful_client();
    // let builder = contentful::QueryBuilder::new()
    //     .content_type_is("richTextPageLanguagesWrapper")
    //     .include(10)
    //     .field_equals("fields.slug", &slug);
    let query_string = format!("?content_type=richTextPageLanguagesWrapper&include=10&fields.slug={}", slug);
    let pages = contentful_client.get_entries_by_query_string::<RichTextPageLanguagesWrapper>(&query_string).await;
    match pages {
        Ok(found_pages) => {
            if found_pages.len() != 1 {
                return Err(ServerFnError::ServerError("Found none or more than one".to_string()));
            }
            let english_rich_text_content = found_pages[0].english.rich_text_content.clone();
            dbg!(english_rich_text_content);
            Ok(found_pages[0].clone())
        },
        Err(e) => Err(ServerFnError::ServerError(e.to_string())),
    }
}

pub fn get_contentful_client() -> contentful::ContentfulClient {
    let access_token = env::var("CONTENTFUL_ACCESS_TOKEN").unwrap();
    const SPACE_ID: &str = "e3magj9g6dp1";
    // let base_url = "https://cdn.contentful.com/spaces";
    // const ENVIRONMENT_ID: &str = "master";
    // return Client::new(&access_token, SPACE_ID, base_url, ENVIRONMENT_ID);
    return contentful::ContentfulClient::new(&access_token, SPACE_ID);
}
